# coding: utf-8

"""
    DLCM-Solution

    DLCM application wrapping all modules, All-In-One  # noqa: E501

    The version of the OpenAPI document: 2.1.1
    Contact: eresearch-opensource@unige.ch
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from dlcmapi_client.configuration import Configuration


class Dip(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'links': 'object',
        'aip_ids': 'list[str]',
        'creation': 'ChangeInfo',
        'info': 'AipInfo',
        'last_update': 'ChangeInfo',
        'ready': 'bool',
        'res_id': 'str'
    }

    attribute_map = {
        'links': '_links',
        'aip_ids': 'aipIds',
        'creation': 'creation',
        'info': 'info',
        'last_update': 'lastUpdate',
        'ready': 'ready',
        'res_id': 'resId'
    }

    def __init__(self, links=None, aip_ids=None, creation=None, info=None, last_update=None, ready=None, res_id=None, local_vars_configuration=None):  # noqa: E501
        """Dip - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._links = None
        self._aip_ids = None
        self._creation = None
        self._info = None
        self._last_update = None
        self._ready = None
        self._res_id = None
        self.discriminator = None

        if links is not None:
            self.links = links
        if aip_ids is not None:
            self.aip_ids = aip_ids
        if creation is not None:
            self.creation = creation
        if info is not None:
            self.info = info
        if last_update is not None:
            self.last_update = last_update
        if ready is not None:
            self.ready = ready
        if res_id is not None:
            self.res_id = res_id

    @property
    def links(self):
        """Gets the links of this Dip.  # noqa: E501

        The _links_ list of the _dip_ resource  # noqa: E501

        :return: The links of this Dip.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Dip.

        The _links_ list of the _dip_ resource  # noqa: E501

        :param links: The links of this Dip.  # noqa: E501
        :type: object
        """

        self._links = links

    @property
    def aip_ids(self):
        """Gets the aip_ids of this Dip.  # noqa: E501

        The source AIP IDs of the DIP  # noqa: E501

        :return: The aip_ids of this Dip.  # noqa: E501
        :rtype: list[str]
        """
        return self._aip_ids

    @aip_ids.setter
    def aip_ids(self, aip_ids):
        """Sets the aip_ids of this Dip.

        The source AIP IDs of the DIP  # noqa: E501

        :param aip_ids: The aip_ids of this Dip.  # noqa: E501
        :type: list[str]
        """

        self._aip_ids = aip_ids

    @property
    def creation(self):
        """Gets the creation of this Dip.  # noqa: E501


        :return: The creation of this Dip.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._creation

    @creation.setter
    def creation(self, creation):
        """Sets the creation of this Dip.


        :param creation: The creation of this Dip.  # noqa: E501
        :type: ChangeInfo
        """

        self._creation = creation

    @property
    def info(self):
        """Gets the info of this Dip.  # noqa: E501


        :return: The info of this Dip.  # noqa: E501
        :rtype: AipInfo
        """
        return self._info

    @info.setter
    def info(self, info):
        """Sets the info of this Dip.


        :param info: The info of this Dip.  # noqa: E501
        :type: AipInfo
        """

        self._info = info

    @property
    def last_update(self):
        """Gets the last_update of this Dip.  # noqa: E501


        :return: The last_update of this Dip.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._last_update

    @last_update.setter
    def last_update(self, last_update):
        """Sets the last_update of this Dip.


        :param last_update: The last_update of this Dip.  # noqa: E501
        :type: ChangeInfo
        """

        self._last_update = last_update

    @property
    def ready(self):
        """Gets the ready of this Dip.  # noqa: E501

        If DIP package is ready  # noqa: E501

        :return: The ready of this Dip.  # noqa: E501
        :rtype: bool
        """
        return self._ready

    @ready.setter
    def ready(self, ready):
        """Sets the ready of this Dip.

        If DIP package is ready  # noqa: E501

        :param ready: The ready of this Dip.  # noqa: E501
        :type: bool
        """

        self._ready = ready

    @property
    def res_id(self):
        """Gets the res_id of this Dip.  # noqa: E501

        The _dip_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :return: The res_id of this Dip.  # noqa: E501
        :rtype: str
        """
        return self._res_id

    @res_id.setter
    def res_id(self, res_id):
        """Sets the res_id of this Dip.

        The _dip_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :param res_id: The res_id of this Dip.  # noqa: E501
        :type: str
        """

        self._res_id = res_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Dip):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Dip):
            return True

        return self.to_dict() != other.to_dict()
